
/*********************************************
This program is for testing NBFM in BF537
Written By: S.M. Hasan, hasan@vt.edu
*********************************************/

#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <limits.h>

/****************************************************************************
  Sound Include files and define
*****************************************************************************/
#include <getopt.h>
//#include <lib/libm/mathf.h>
#include <linux/soundcard.h>

#define	DACDEVICE	"/dev/dsp"
//#define	MAXFREQ		50000
//#define	BUFSIZE		(2*MAXFREQ)
//short	buf[BUFSIZE];
//#define	PI	((float) 3.141592654)
/*****************************************************************************/

#include "ppi.h"
#include "sigproc.h"

UINT16 *IQ;

int main(int argc,char *argv[])
{
	// Setting up variables and default values

	int	ppiFD, n, i, j;
	char	mode;
	int	retval;
	UINT16	bufX = LINELEN;
	UINT16	bufY = NUMLINES;
	int	dims, size;
	size = BUFFERSIZE;
	dims = DIM2D;
	char	buf[size];
	UINT16 i_in_raw[size/2], q_in_raw[size/2];
	short i_in[size/2], q_in[size/2];
	FILE *ofp, *ofpi, *ofpq;

	// Variables initialization
	i=0;
	char ofilename[] = "out.txt";
	char ofilename1[] = "i_in.txt";
	char ofilename2[] = "q_in.txt";
	
	// PPI Initialization 
	
	if (argc < 2){
		showUsage(argv[0]);
		return(1);
	}
	else {
		mode = *argv[1];
	}
	ppiFD = open("/dev/ppi0", O_RDWR);

	if (ppiFD < 0)
	{
		perror("Error opening /dev/ppi");
		return(-1);
	}
	else {
		printf("fd(%d) = open(/dev/ppi) \n", ppiFD );
	}

	// Sound Card Initialization
	printf("SoundCard initialization started.... \n");

	int	ofd, ii, c, endian;
	int	replayfreq, wavefreq;

	replayfreq = 48000;
	wavefreq = 10000;
	endian = AFMT_S16_LE;

	printf("SoundCard variable initialization finished.... \n");

/*
	if (optind == (argc - 1)) {
		wavefreq = atoi(argv[optind]);
		if ((wavefreq < 1) || (wavefreq > replayfreq)) {
			printf("ERROR: invalid wave frequency %d, range "
				"1-%d\n", wavefreq, replayfreq);
			exit(1);
		}
	}
*/
	printf("SoundCard opening.... \n");

	if ((ofd = open(DACDEVICE, O_RDWR)) < 1) {
		printf("ERROR: failed to open DAC device %s\n", DACDEVICE);
		exit(1);
	}
	else {
		printf("fd(%d) = open(/dev/dsp)\n", ofd );
	}

	printf("SoundCard IOC started.... \n");	

	if (ioctl(ofd, SNDCTL_DSP_SPEED, &replayfreq) < 0) {
		printf("ERROR: ioctl(SNDCTL_DSP_SPEED,%d) failed, "
			"errno=%d\n", replayfreq, errno);
		exit(1);
	}
	else {
		printf("Configured SNDCTL_DSP_SPEED.... \n");
	}

	ii = 1;
	if (ioctl(ofd, SNDCTL_DSP_STEREO, &ii) < 0) {
		printf("ERROR: ioctl(SNDCTL_DSP_STEREO,%d) failed, "
			"errno=%d\n", errno, ii);
		exit(1);
	}
	else {
		printf("Configured SNDCTL_DSP_STEREO.... \n");
	}

	if (ioctl(ofd, SNDCTL_DSP_SAMPLESIZE, &endian) < 0) {
		printf("ERROR: ioctl(SNDCTL_DSP_SAMPLESIZE,0x%x) failed, "
			"errno=%d\n", errno, ii);
		exit(1);
	}
	else {
		printf("Configured SNDCTL_DSP_SAMPLESIZE.... \n");
	}





	// PPI data reading; I and Q extraction

	//printf("beSlave()\n");
	beSlave(ppiFD, IQ, bufX, bufY, dims);
/*
	for (n=0; n<size; n++)			// testing the incoming data directly from PPI
		{
			printf("Printing IQ values in main [%d]= %4hX\n", n, *IQ);
			IQ++;
		}
*/


// main for loop- for streaming the data

//int ii;

//for (ii=0; ii<1; ii++)

//{

	while (i<size/2)
   	 {
		i_in_raw[i]= *IQ;
		q_in_raw[i]= *(IQ+1);
		i++;
		IQ=IQ+2;
   	  }
/*
	for (n=0; n<size/2; n++)		// testing the extracted I and Q data
		{
			printf("Printing I in main [%d]= %4hX\n", n, i_in[n]);
			printf("Printing Q in main [%d]= %4hX\n", n, q_in[n]);
		}
*/


	// Converting Unsigned Short data into signed short data

	




     /***************************************
     Signal processing
     **************************************/
    float scale_factor = 6500.0*SHRT_MAX; //15000.0*15000.0;
    short err, cv, out[size/2], i_nco, q_nco, nco_i_in, nco_q_in;
    float gain_out;
    ofp = fopen(ofilename,"w");
    ofpi = fopen(ofilename1,"w");
    ofpq = fopen(ofilename2,"w");
    int freq_index= 0;
    int max_freq_index = 62832;
    //cv= 0; // Initialization
    //i_nco=0;
    //q_nco=0;

    int prev_max=1; // SHRT_MAX;
    int cur_max= 0;

    nco_i_in= 20000;
    nco_q_in= 20000;
 

    i=0;
	while (i<size/2)
   	 {
		i_in[i]= (i_in_raw[i]-SHRT_MAX);
		q_in[i]= (q_in_raw[i]-SHRT_MAX);
		i++;
   	  }	
	

    for (j=1; j<size/2; j++)

    {
	if (i_in[j] > cur_max)
		cur_max= i_in[j];	
	
	float agc= 1600.0/prev_max;
	
	gain_out= 0;
        //nco(cv, &i_nco, &q_nco);
	//err= phase_detect(i_in[j], q_in[j], i_nco, q_nco, scale_factor);
 	
	//err= phase_detect(i_in[j]*agc, q_in[j]*agc, i_in[j-1]*agc, q_in[j-1]*agc, scale_factor);  	// <<==== Quadrature-delay modulator
     	err= phase_detect(i_in[j]*agc, q_in[j]*agc, nco_i_in, nco_q_in, scale_factor);  	// <<==== Quadrature-delay modulator
	
	gain_out= gain(35000.0/SHRT_MAX, err); 	// gain(1.0, err); 		// <<=== gain adjustment
	out[j-1]= gain_out;
	//printf("the value of gain= %f \n",gain_ouit);
	
	cv= gain_out;
	//printf("the value of cv end= %f \n",cv);


//========================================
         if (cv > USHRT_MAX/4)
 	        cv = USHRT_MAX/4;
 	    else if (cv < -USHRT_MAX/4)
 	        cv = USHRT_MAX/4;
 	
 	    freq_index += cv;
 	    if (freq_index > max_freq_index)
 	        freq_index = freq_index - max_freq_index;
 	    else if (freq_index < 0)
 	        freq_index = freq_index + max_freq_index;
 
//==========================================
	nco_i_in= nco_i(cv, freq_index , 30000,max_freq_index);
	nco_q_in= nco_q(cv, freq_index, 30000, max_freq_index);
        
        fprintf(ofp,"%d\n",out[j-1]*15);
	//fprintf(ofp,"%d = %4hX \n",i_in[j-1], i_in[j-1]);
	//fprintf(ofpi,"%d\n",i_in_raw[j]);				// writing the incoming I and Q data into a file
	//fprintf(ofpq,"%d\n",q_in_raw[j]);
	fprintf(ofpi,"%d\n", i_in[j]);				// writing the incoming I and Q data into a file
	fprintf(ofpq,"%d\n", q_in[j]);

	//printf("Printing i_in [%d]= %d\n", j, i_in[j]);
	
	prev_max= cur_max;
/*	
	if (prev_max < 5000) // Poor mans squelch
		return;
*/

    }

//} //ending main for loop
    
    	


	//printf ("The value of output is = %f \n", out[200]);
    
    	/* Close Files */
    	fclose(ofp);
    	fclose(ofpi);
    	fclose(ofpq);    
    
   	 printf ("Output is written into a file 'out.txt'..... \n");
   	 printf ("Ended the program ....... \n");


	// Sending data to the Sound Card
	
	printf("Sending data to the sound card...\n");
	for (;;) {
		if ((ii = write(ofd, out, size/2)) != size/2) {
			printf("ERROR: write(%s) failed, ii=%d, errno=%d\n",
				DACDEVICE, i, errno);
		}
	}

	// Sound card closing
	//close(ofd);

	// PPI Closing
	closePPI(ppiFD);
	
	printf (" main program finished \n");
	return (0);

}
