module FIFO_DA (
	rst_b,
	// Input side
	wrclk,		// 120MHz
	data,
	done,		// from FIR output
	// Output side
	rdclk,		// 7.5MHz
	odata
	);
input		rst_b;
input		wrclk;
input	[11:0]	data;
input		done;

input		rdclk;
output	[13:0]	odata;

 reg	[13:0]	odata;
 reg	[1:0]	ns_wrcnt,wrcnt;
 reg		rdreq;
 wire		ns_rdreq;
 wire	[11:0]	dtemp0;

 assign	ns_rdreq=(&wrcnt);

 always @(done or wrcnt)
 begin
	 ns_wrcnt=wrcnt;
	 if (wrcnt==2'b11)
		 ns_wrcnt=wrcnt;
	 else
	 begin
		 if (done==1)
			 ns_wrcnt=wrcnt+1'b1;
	 end
 end

 always @(posedge wrclk or negedge rst_b)
 begin
	 if (~rst_b)
	 begin
		 wrcnt<=2'b00;
	 end
	 else
	 begin
		 wrcnt<=ns_wrcnt;
	 end
 end

 always @(posedge rdclk or negedge rst_b)
 begin
	 if (~rst_b)
	 begin
		 rdreq<=1'b0;
		 odata<=4'h0000;
	 end
	 else
	 begin
		 rdreq<=ns_rdreq;
		 odata<={dtemp0,2'b00};
	 end
 end

 myFIFO	inst_myFIFO (
	 	     .data(data),
		     .wrreq(done),
		     .rdreq(rdreq),
		     .rdclk(rdclk),
		     .wrclk(wrclk),
		     .aclr(~rst_b),
		     .q(dtemp0));

endmodule
