%                                                                                                                                       
%THIS IS A WIZARD GENERATED FILE. DO NOT EDIT THIS FILE!                                                                                
%                                                                                                                                       
%---------------------------------------------------------------------------------------------------------                              
%This is a filter with variable coefficients combine with interpolatipon and decimation                                                 
%Please input:                                                                                                                          
%data vector: 		stimulation(1:n)                                                                                                 
%coefficient matrix:	coef_matrix(n * interpolation_factor,m). n is the input data length, m is the coefficients length.              
%                       coef_matrix(1,:) coressponds to coefficient at time unit 1.                                                     
%                       coef_matrix(2,:) coressponds to coefficient at time unit 2.                                                     
%                                                                                                                                       
%                       coef_matrix(n,:) coressponds to coefficient at time unit n.                                                     
%                                                                                                                                       
%FILTER PARAMETER                                                                                                                       
%Input Data Type:	UnSigned
%Input Data Width:	12
%MSB Truncation Bits: 4
%MSB Truncated
%MSB Satuated
%LSB Truncation bits: 15
%LSB Truncated
%LSB Rounded
%OUTPUT Data Width:   31
%-----------------------------------------------------------------------------------------------------------

	%MegaWizard Scaled Coefficient Values
	function  output = FIR_lowf_st_mat (stimulation, output)
	coef_matrix=[191 151 103 46 -15 -81 -149 -215 -277 -333 -379 -413 -433 -436 -421 -387 -332 -257 -162 -47 84 231 392 562 738 918 1096 1269 1432 1583 1717 1832 1924 1992 2033 2047 2033 1992 1924 1832 1717 1583 1432 1269 1096 918 738 562 392 231 84 -47 -162 -257 -332 -387 -421 -436 -433 -413 -379 -333 -277 -215 -149 -81 -15 46 103 151 191 ];
  
	INTER_FACTOR  = 1;
	DECI_FACTOR  = 1; 
	MSB_RM  = 4;
	MSB_TYPE  = 0;
	LSB_RM  = 15;
	LSB_TYPE  = 0;
	FIR_WIDTH  = 31;
	OUT_WIDTH  = FIR_WIDTH - MSB_RM - LSB_RM;
	DATA_WIDTH = 12;
            
	data_type= 2;
	OUT_TYPE= 2;

        % check size of inputs.
        [DX,DY] = size(stimulation);
        [CX,CY] = size(coef_matrix);
        for i=1:CX
        	for j=1:CY
        		if( coef_matrix(i,j) < 0)
        			OUT_TYPE = 1;
        		end
        	end
         end
        
        
        %fill coef_matrix to length of data with the latest coef set
        if (CX < DY * INTER_FACTOR)
            for i= CX +1:DY * INTER_FACTOR
                coef_matrix(i,:) = coef_matrix(CX,:);
            end
        end

        %check if input is integer
       	int_sti=round(stimulation);
	    T = (int_sti ~= stimulation);
	    if (max(T)~=0)
	        fprintf('WARNING : Integer Input Expected: Rounding Fractional Input to Nearest Integer...\n');
	    end
	    
	    %Input overflow check
	    switch  data_type
	    case 1
	        %set max/min for signed
	        maxdat = 2^(DATA_WIDTH-1)-1;
	        mindat = -maxdat-1;
	    case 2
	        %set max/min for unsigned
	        maxdat = 2^DATA_WIDTH-1;
	        mindat = 0;
	    end

	    %Saturating Input Value
	    a=find(int_sti>maxdat);
	    b=find(int_sti<mindat);
	    if (~isempty(a)|~isempty(b))
	 	    fprintf('WARNING : Input Amplitude Exceeds MAXIMUM/MINIMUM allowable values - saturating input values...\n');
	            lena = length (a);
	            lenb = length (b);
	            for i =1:lena
	        	    fprintf('%d > %d \n', int_sti(a(i)), maxdat);
			        int_sti(a(i)) = maxdat;
		        end
		    for i =1:lenb
			    fprintf('%d < %d \n', int_sti(b(i)), mindat);
			    int_sti(b(i)) = mindat;
		    end
	    end
        
	    % Add interpolation
   	    inter_sti = zeros(1, INTER_FACTOR * length(int_sti));
	    inter_sti(1:INTER_FACTOR:INTER_FACTOR * length(int_sti)) = int_sti;

        
        for i = 1 : DY *INTER_FACTOR
    	    coef_current = coef_matrix(i,:);
            output_temp(i) = simp_adaptive (inter_sti, coef_current, i);
        end
	% Truncate output
	len1 = length(output_temp);
	
	    switch  LSB_TYPE
	    case 0
	        %truncate
            out_dec = bi_trunc_lsb(output_temp,LSB_RM,FIR_WIDTH, OUT_TYPE);
	    case 1
	        %round
            out_dec = bi_round(output_temp,LSB_RM, FIR_WIDTH, OUT_TYPE);
	    end
        
 	    switch  MSB_TYPE
	    case 0
	        %truncate
            out_dec = bi_trunc_msb(out_dec,MSB_RM,FIR_WIDTH-LSB_RM, OUT_TYPE);
	    case 1
	        %round
            out_dec = bi_satu(out_dec,MSB_RM, FIR_WIDTH-LSB_RM, OUT_TYPE);
	    end
 	   
    	% choose decimation output in phase=DECI_FACTOR-1  
     	if(DECI_FACTOR == 1)
     		output = out_dec;
     	else
     		output = out_dec(DECI_FACTOR:DECI_FACTOR:len1);
 	    end 
 	      
  	function[output, outindex] = simp_adaptive (int_sti, coef_current, data_index, output)
	%Simulation is the whole input sequence
	%coef_current is the current coefficient set
	%data_index gives the last data to use
	%outputs are the sum of input and coef multiplication
	%outindex is the next data_index
   
	sti_current = zeros(length(coef_current),1);
	
	data_length = length(int_sti);
	
	%Check data index
	if (data_index > data_length)
		fprintf('ERROR: DATA INDEX IS LARGER THAN DATA LENGTH!!!\n');
		return;
	end
	for i = 1: length(coef_current)
	   if ((data_index -i+1)>0 & (data_index - i+1)<=data_length)
	      sti_current(i,1) = int_sti(data_index - i+1);
	   end
	end
	
	outindex= data_index+1;
	output = coef_current * sti_current;
	% end of function simp_adaptive

	function output = bi_round(data_in,LSB_RM,ORI_WIDTH, OUT_TYPE, output)
	% LSB_RM is the bit to lose in LSB
	% ORI_WIDTH is the original data width
	data = round (data_in / 2^LSB_RM);
    if(OUT_TYPE == 2)
       	output = bi_satu(data,0,ORI_WIDTH+1 - LSB_RM, OUT_TYPE);
    else
       	output = bi_satu(data,0,ORI_WIDTH - LSB_RM, OUT_TYPE);
    end
	%end of function bi_trunc_lsb
	
	function output = bi_trunc_lsb(data_in,LSB_RM,ORI_WIDTH, OUT_TYPE, output)
	% LSB_RM is the bit to lose in LSB
	% ORI_WIDTH is the original data width
	%2's complement system
    if(OUT_TYPE == 2)
           ORI_WIDTH = ORI_WIDTH + 1;
    end
	output = bitshift(2^ORI_WIDTH*(data_in<0) + data_in, -LSB_RM) - 2^(ORI_WIDTH-LSB_RM) *(data_in<0);
	% end of function bi_round
	
	function output = bi_trunc_msb(data_in,MSB_RM,ORI_WIDTH, OUT_TYPE, output)
	% MSB_RM is the bit to lose in LSB
	% ORI_WIDTH is the original data width
	%2's complement system
	if(OUT_TYPE == 2)
		data = data_in;
	else
		data = 2^ORI_WIDTH * (data_in < 0)+ data_in;
	end
	erase_num = 2^(ORI_WIDTH - MSB_RM) - 1;
	data = bitand(data, erase_num);
    if(OUT_TYPE == 2)
      	output = data;
    else
		output = data - 2^(ORI_WIDTH - MSB_RM)*(bitget(data,ORI_WIDTH - MSB_RM));
    end
	%end of bi_trunc_msb
	
	function output = bi_satu(data_in,MSB_RM,ORI_WIDTH, OUT_TYPE, output)
	% MSB_RM is the bit to lose in LSB
	% ORI_WIDTH is the original data width
	%2's complement system
    if(OUT_TYPE == 2)
      	maxdat = 2^(ORI_WIDTH - MSB_RM)-1;
      	mindat = 0;
    else
      	maxdat = 2^(ORI_WIDTH - MSB_RM -1)-1;
      	mindat = 2^(ORI_WIDTH - MSB_RM -1)*(-1);
    end
	data_in(find(data_in > maxdat)) = maxdat;
	data_in(find(data_in < mindat)) = mindat;
	output = data_in;
	%end of bi_satu 
